---------------------------------------------------------------------------------------------------
--file contenente la struttura dei personaggi ,la lora IA,il controllo dell'input e i movimenti.
-- Struttura di boxboy
Boy = {}
Boy.x = 0
Boy.y = 0
Boy.tileX = 8       -- Tile orizzontale.
Boy.tileY = 5     -- Tile verticale
Boy.facing = "down" -- direzione in cui si sta muovendo boxboy
Boy.quads = {       -- Frame dello sprite
        down =      love.graphics.newQuad(0,0,32,64,256,64),
        downright = love.graphics.newQuad(32,0,32,64,256,64),
        right =     love.graphics.newQuad(64,0,32,64,256,64),
        upright =   love.graphics.newQuad(96,0,32,64,256,64),
        up =        love.graphics.newQuad(128,0,32,64,256,64),
        upleft =    love.graphics.newQuad(160,0,32,64,256,64),
        left =      love.graphics.newQuad(192,0,32,64,256,64),
        downleft =  love.graphics.newQuad(224,0,32,64,256,64),
    }

--------------------------------------------------------------------------------------------------- 
-- Carica sprite boxboy
Boy.image = love.graphics.newImage("images/guy.png")
Boy.width = Boy.image:getWidth()
Boy.height = Boy.image:getHeight()

---------------------------------------------------------------------------------------------------
-- Muove boxboy nei tile.
function Boy.moveTile(x,y)

    -- Cambia la direzione di boxboy.
    if x > 0 then Boy.facing = "right"
    elseif x < 0 then Boy.facing = "left"
    elseif y > 0 then Boy.facing = "down"
    else Boy.facing = "up" end
    
    -- Prende il tile in cui si deve muovere.
    local tile = tileLayer(Boy.tileX + x, Boy.tileY + y)

    -- Se il tile non esiste o è un ostacolo,non muoveere.
    if tile == nil then return end
    if tile.properties.obstacle then return end
    
    -- Altrimenti sposta boxboy
    Boy.tileX = Boy.tileX + x
    Boy.tileY = Boy.tileY + y
    Boy.x = Boy.tileX * map.tileWidth
    Boy.y = (Boy.tileY + 1) * map.tileHeight - Boy.height
end

---------------------------------------------------------------------------------------------------
-- Funzione che verrà richiamata nel main, mouve boxboy.

function Boy.keypressed(k)
    if k == "w" then Boy.moveTile(0,-1) end
    if k == "a" then Boy.moveTile(-1,0) end
    if k == "s" then Boy.moveTile(0,1) end
    if k == "d" then Boy.moveTile(1,0) end
end

--Da aggiungere struttura nemici e IA.
return PngManager